#ifndef __LIBTERM_PRINT_UTILS_H
#define __LIBTERM_PRINT_UTILS_H

#include <stdio.h>
#include <stdlib.h>

#include "screen_modes.h"
#include "term.h"

#define READLINE_NONE   0
#define READLINE_ALPHA  1
#define READLINE_TEXT   2
#define READLINE_HIDDEN 3


int term_fprint( screen_mode_e mode, FILE *f );
int term_print( term_screen *ts, const char *s, size_t n );
int term_print_xy( term_screen *ts, const char *buf, size_t size, 
                   int init_column, int init_row);
int term_draw_hline( term_screen *ts, int pc, int pr, int sz, char ch );
int term_getc( term_screen *ts );
int term_putc( term_screen *ts, char c );
int term_readline( term_screen *ts, char *str, size_t str_size, int flag );

#endif
